// The sample contained herein is provided to you "AS IS".
//
// It is furnished by Add-in Express as a simple example and has not been
// thoroughly tested under all conditions. Add-in Express, therefore, cannot
// guarantee its reliability, serviceability or functionality.

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Outlook2000, adxolFormsManager, StdCtrls, ExtCtrls;

type
  TadxOlForm1 = class(TadxOlForm)
    Panel1: TPanel;
    panLog: TPanel;
    Label1: TLabel;
    laCachedType: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edValue: TEdit;
    Label4: TLabel;
    laCreatedTime: TLabel;
    Label5: TLabel;
    laLastEditedTime: TLabel;
    lbLog: TListBox;
    Label6: TLabel;
    procedure adxOlFormCreate(Sender: TObject);
    procedure edValueChange(Sender: TObject);
    procedure adxOlFormADXBeforeFormShow(Sender: TObject);
    procedure adxOlFormShow(Sender: TObject);
    procedure adxOlFormDestroy(Sender: TObject);
  private
    { Private declarations }
    WasEditedInTheLastSession: boolean;
    ProgramaticSettingValue: boolean;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
  end;

{NOTE: The adxOlForm1 variable is intended for the exclusive use
       by the TadxOlFormsCollectionItem Designer.
       NEVER use this variable for other purposes.}
var
  adxOlForm1 : TadxOlForm1;

implementation

uses FormCachingD7_IMPL, uUtils;

{$R *.DFM}

procedure TadxOlForm1.adxOlFormCreate(Sender: TObject);
begin
  laCreatedTime.Caption := DateTimeToStr(Now);
  WasEditedInTheLastSession := false;
  ProgramaticSettingValue := false;
end;

procedure TadxOlForm1.edValueChange(Sender: TObject);
begin
  if (not ProgramaticSettingValue) then begin
    laLastEditedTime.Caption := DateTimeToStr(Now);
    WasEditedInTheLastSession := true;
  end;
end;

procedure TadxOlForm1.adxOlFormADXBeforeFormShow(Sender: TObject);
begin
  //Here you can initialize a form instance.
  WasEditedInTheLastSession := false;
  lbLog.Items.Text := self.FolderObj.Name + #13#10 + lbLog.Items.Text;
end;

procedure TadxOlForm1.adxOlFormShow(Sender: TObject);
begin
  case Item.Cached of
    csOneInstanceForAllFolders:
      laCachedType.Caption := 'csOneInstanceForAllFolders';
    csNewInstanceForEachFolder:
      laCachedType.Caption := 'csNewInstanceForEachFolder';
    csNone:
      laCachedType.Caption := 'csNone';
  end;

  if (Item.Cached = csNone) then begin
      //Here you can initialize a non-cached form instance.
      ProgramaticSettingValue := true;
      edValue.Text := (AddinModule as TAddinModule).SavedValue;
      ProgramaticSettingValue := false;
  end;

  case (Item.ExplorerLayout) of
      elRightSubpane,
      elLeftSubpane:
          panLog.Align := alBottom;
      else begin
          panLog.Align := alRight;
          panLog.Width := lbLog.Left * 2 + lbLog.Width;
      end;
  end;

end;

procedure TadxOlForm1.adxOlFormDestroy(Sender: TObject);
begin
  if (WasEditedInTheLastSession) then begin
    if (Common.ShowQuestion(Strings.SaveChangesQuestion)) then begin
      (AddinModule as TAddinModule).SavedValue := edValue.Text;
    end;
  end;

end;

initialization
  RegisterClass(TPersistentClass(TadxOlForm1));

finalization
end.
